namespace TestProject;

/// <summary>
///  
/// </summary>
public partial class MainForm : Form
{
    //////////////////////////////////////////////////////////////////////////////////////////////////// Field
    ////////////////////////////////////////////////////////////////////////////////////////// Private

    #region Field

    /// <summary>
    ///  
    /// </summary>
    private double scaleRate = 2.0d;

    #endregion

    //////////////////////////////////////////////////////////////////////////////////////////////////// Constructor
    ////////////////////////////////////////////////////////////////////////////////////////// Public

    #region  - MainForm()

    /// <summary>
    /// 
    /// </summary>
    public MainForm()
    {
        InitializeComponent();

        KeyPreview = true;

        this.timer.Interval = 50;

        MouseWheel                     += Form_MouseWheel;
        this.timer.Tick                += timer_Tick;
        this.scaleInButton.MouseClick  += scaleInButton_MouseClick;
        this.scaleOutButton.MouseClick += scaleOutButton_MouseClick;

        this.timer.Start();
    }

    #endregion

    //////////////////////////////////////////////////////////////////////////////////////////////////// Method
    ////////////////////////////////////////////////////////////////////////////////////////// Private

    #region  콺  óϱ - Form_MouseWheel(sender, e)

    /// <summary>
    ///  콺  óϱ
    /// </summary>
    /// <param name="sender">̺Ʈ ߻</param>
    /// <param name="e">̺Ʈ </param>
    private void Form_MouseWheel(object sender, MouseEventArgs e)
    {
        if(e.Delta < 0 && this.scaleRate > 0.2d)
        {
            this.scaleRate -= 0.1d;
        }
        else if(e.Delta > 0 && this.scaleRate < 5.0d)
        {
            this.scaleRate += 0.1d;
        }
    }

    #endregion
    #region Ÿ̸ ƽ óϱ - timer_Tick(sender, e)

    /// <summary>
    /// Ÿ̸ ƽ óϱ
    /// </summary>
    /// <param name="sender">̺Ʈ ߻</param>
    /// <param name="e">̺Ʈ </param>
    private void timer_Tick(object sender, EventArgs e)
    {
        this.scaleLabel.Text = $" : {this.scaleRate:#.00}";

        Size size = new Size(this.pictureBox.Width, this.pictureBox.Height);

        Bitmap bitmap = new Bitmap((int)(size.Width / this.scaleRate), (int)(size.Height / this.scaleRate));

        using Graphics graphics = Graphics.FromImage(bitmap);

        graphics.CopyFromScreen
        (
            (int)(MousePosition.X - size.Width  / (this.scaleRate * 2)),
            (int)(MousePosition.Y - size.Height / (this.scaleRate * 2)),
            0,
            0,
            size,
            CopyPixelOperation.SourceCopy
        );

        Bitmap temporaryBitmap = this.pictureBox.Image as Bitmap;

        this.pictureBox.Image = bitmap;

        if(temporaryBitmap != null)
        {
            temporaryBitmap.Dispose();
        }
    }

    #endregion
    #region Ȯ ư Ŭ óϱ - scaleInButton_MouseClick(sender, e)

    /// <summary>
    /// Ȯ ư Ŭ óϱ
    /// </summary>
    /// <param name="sender">̺Ʈ ߻</param>
    /// <param name="e">̺Ʈ </param>
    private void scaleInButton_MouseClick(object sender, MouseEventArgs e)
    {
        if(e.Button == MouseButtons.Left && this.scaleRate < 5.0d)
        {
            this.scaleRate += 0.1d;
        }
    }

    #endregion
    #region  ư Ŭ óϱ - scaleOutButton_MouseClick(sender, e)

    /// <summary>
    ///  ư Ŭ óϱ
    /// </summary>
    /// <param name="sender">̺Ʈ ߻</param>
    /// <param name="e">̺Ʈ </param>
    private void scaleOutButton_MouseClick(object sender, MouseEventArgs e)
    {
        if(e.Button == MouseButtons.Left && this.scaleRate > 0.2d)
        {
            this.scaleRate -= 0.1d;
        }
    }

    #endregion
}